diff --git a/src/screen.c b/src/screen.c
index 33cb3cc..12ac091 100644
--- a/src/screen.c
+++ b/src/screen.c
@@ -2679,7 +2747,7 @@ pushScreenGrab (CompScreen *s,
 	status = XGrabPointer (s->display->display, s->grabWindow, TRUE,
 			       POINTER_GRAB_MASK,
 			       GrabModeAsync, GrabModeAsync,
-			       s->root, cursor,
+			       s->root.id, cursor,
 			       CurrentTime);
 
 	if (status == GrabSuccess)
@@ -2831,7 +2899,7 @@ grabUngrabOneKey (CompScreen   *s,
 	XGrabKey (s->display->display,
 		  keycode,
 		  modifiers,
-		  s->root,
+		  s->root.id,
 		  TRUE,
 		  GrabModeAsync,
 		  GrabModeAsync);
@@ -2841,7 +2909,7 @@ grabUngrabOneKey (CompScreen   *s,
 	XUngrabKey (s->display->display,
 		    keycode,
 		    modifiers,
-		    s->root);
+		    s->root.id);
     }
 }
 
@@ -2971,7 +3039,7 @@ updatePassiveKeyGrabs (CompScreen *s)
 {
     int i;
 
-    XUngrabKey (s->display->display, AnyKey, AnyModifier, s->root);
+    XUngrabKey (s->display->display, AnyKey, AnyModifier, s->root.id);
 
     for (i = 0; i < s->nKeyGrab; i++)
     {
@@ -3127,7 +3195,7 @@ computeWorkareaForBox (CompScreen *s,
 
     XUnionRegion (&r, region, region);
 
-    for (w = s->windows; w; w = w->next)
+    for (w = s->root.windows; w; w = w->next)
     {
 	if (!w->mapNum)
 	    continue;
@@ -3241,7 +3309,7 @@ updateWorkareaForScreen (CompScreen *s)
 
 	/* as work area changed, update all maximized windows on this
 	   screen to snap to the new work area */
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	    updateWindowSize (w);
     }
 }
@@ -3308,6 +3376,9 @@ updateClientListForScreen (CompScreen *s)
     Bool   updateClientListStacking = FALSE;
     int	   i, n = 0;
 
+    if (!s->root.substructureRedirect)
+	return;
+
     forEachWindowOnScreen (s, countClientListWindow, (void *) &n);
 
     if (n == 0)
@@ -3319,11 +3390,11 @@ updateClientListForScreen (CompScreen *s)
 	    s->clientList  = NULL;
 	    s->nClientList = 0;
 
-	    XChangeProperty (s->display->display, s->root,
+	    XChangeProperty (s->display->display, s->root.id,
 			     s->display->clientListAtom,
 			     XA_WINDOW, 32, PropModeReplace,
 			     (unsigned char *) &s->grabWindow, 1);
-	    XChangeProperty (s->display->display, s->root,
+	    XChangeProperty (s->display->display, s->root.id,
 			     s->display->clientListStackingAtom,
 			     XA_WINDOW, 32, PropModeReplace,
 			     (unsigned char *) &s->grabWindow, 1);
@@ -3379,13 +3450,13 @@ updateClientListForScreen (CompScreen *s)
     }
 
     if (updateClientList)
-	XChangeProperty (s->display->display, s->root,
+	XChangeProperty (s->display->display, s->root.id,
 			 s->display->clientListAtom,
 			 XA_WINDOW, 32, PropModeReplace,
 			 (unsigned char *) clientList, s->nClientList);
 
     if (updateClientListStacking)
-	XChangeProperty (s->display->display, s->root,
+	XChangeProperty (s->display->display, s->root.id,
 			 s->display->clientListStackingAtom,
 			 XA_WINDOW, 32, PropModeReplace,
 			 (unsigned char *) clientListStacking, s->nClientList);
@@ -3439,7 +3510,8 @@ toolkitAction (CompScreen *s,
     XUngrabPointer (s->display->display, CurrentTime);
     XUngrabKeyboard (s->display->display, CurrentTime);
 
-    XSendEvent (s->display->display, s->root, FALSE, StructureNotifyMask, &ev);
+    XSendEvent (s->display->display, s->root.id, FALSE, StructureNotifyMask,
+		&ev);
 }
 
 void
@@ -3510,7 +3582,7 @@ moveScreenViewport (CompScreen *s,
     tx *= -s->width;
     ty *= -s->height;
 
-    for (w = s->windows; w; w = w->next)
+    for (w = s->root.windows; w; w = w->next)
     {
 	if (windowOnAllViewports (w))
 	    continue;
@@ -3581,7 +3653,7 @@ moveWindowToViewportPosition (CompWindow *w,
     {
 	int m, wx, wy;
 
-	if (!w->managed)
+	if (w->attrib.override_redirect)
 	    return;
 
 	if (w->type & (CompWindowTypeDesktopMask | CompWindowTypeDockMask))
@@ -3698,7 +3770,7 @@ applyStartupProperties (CompScreen *screen,
     {
 	CompWindow *leader;
 
-	leader = findWindowAtScreen (screen, window->clientLeader);
+	leader = findSibling (window, window->clientLeader);
 	if (leader)
 	    startupId = leader->startupId;
 
@@ -3752,7 +3824,7 @@ sendWindowActivationRequest (CompScreen *s,
     xev.xclient.data.l[4] = 0;
 
     XSendEvent (s->display->display,
-		s->root,
+		s->root.id,
 		FALSE,
 		SubstructureRedirectMask | SubstructureNotifyMask,
 		&xev);
@@ -3813,12 +3885,12 @@ disableScreenEdge (CompScreen *s,
 }
 
 Window
-getTopWindow (CompScreen *s)
+getTopWindow (CompWindow *parent)
 {
     CompWindow *w;
 
     /* return first window that has not been destroyed */
-    for (w = s->reverseWindows; w; w = w->prev)
+    for (w = parent->reverseWindows; w; w = w->prev)
     {
 	if (w->id > 1)
 	    return w->id;
@@ -3830,24 +3902,30 @@ getTopWindow (CompScreen *s)
 void
 makeScreenCurrent (CompScreen *s)
 {
-    if (currentRoot != s->root)
+    if (manualCompositeManagement)
     {
-	glXMakeCurrent (s->display->display, s->output, s->ctx);
-	currentRoot = s->root;
-    }
+	if (currentRoot != s->root.id)
+	{
+	    glXMakeCurrent (s->display->display, s->output, s->ctx);
+	    currentRoot = s->root.id;
+	}
 
-    s->pendingCommands = TRUE;
+	s->pendingCommands = TRUE;
+    }
 }
 
 void
 finishScreenDrawing (CompScreen *s)
 {
-    if (s->pendingCommands)
+    if (manualCompositeManagement)
     {
-	makeScreenCurrent (s);
-	glFinish ();
+	if (s->pendingCommands)
+	{
+	    makeScreenCurrent (s);
+	    glFinish ();
 
-	s->pendingCommands = FALSE;
+	    s->pendingCommands = FALSE;
+	}
     }
 }
 
@@ -3894,7 +3972,7 @@ setNumberOfDesktops (CompScreen   *s,
     if (s->currentDesktop >= nDesktop)
 	s->currentDesktop = nDesktop - 1;
 
-    for (w = s->windows; w; w = w->next)
+    for (w = s->root.windows; w; w = w->next)
     {
 	if (w->desktop == 0xffffffff)
 	    continue;
@@ -3915,6 +3993,9 @@ setCurrentDesktop (CompScreen   *s,
     unsigned long data;
     CompWindow    *w;
 
+    if (!s->root.substructureRedirect)
+	return;
+
     if (desktop >= s->nDesktop)
 	return;
 
@@ -3923,7 +4004,7 @@ setCurrentDesktop (CompScreen   *s,
 
     s->currentDesktop = desktop;
 
-    for (w = s->windows; w; w = w->next)
+    for (w = s->root.windows; w; w = w->next)
     {
 	if (w->desktop == 0xffffffff)
 	    continue;
@@ -3936,7 +4017,7 @@ setCurrentDesktop (CompScreen   *s,
 
     data = desktop;
 
-    XChangeProperty (s->display->display, s->root,
+    XChangeProperty (s->display->display, s->root.id,
 		     s->display->currentDesktopAtom,
 		     XA_CARDINAL, 32, PropModeReplace,
 		     (unsigned char *) &data, 1);
@@ -4292,6 +4373,14 @@ setWindowPaintOffset (CompScreen *s,
 		      int        x,
 		      int        y)
 {
-    s->windowOffsetX = x;
-    s->windowOffsetY = y;
+    x = (s->x * s->width) - x;
+    x = MOD (x, s->hsize * s->width);
+    x -= (s->x * s->width);
+
+    y = (s->y * s->height) - y;
+    y = MOD (y, s->vsize * s->height);
+    y -= (s->y * s->height);
+
+    s->root.viewportOffsetX = -x;
+    s->root.viewportOffsetY = -y;
 }
